program day2
    implicit none
    integer, parameter :: path_length = 100
    character(path_length) :: fname
    integer :: n_arguments
    integer, allocatable :: intcode(:)
    integer :: n_codes

    n_arguments = command_argument_count()
    if (n_arguments .eq. 1) then
        call get_command_argument(1, fname)
        print *, "File: ", fname
    else
        print *, "Wrong number of arguments: ", n_arguments
        stop
    end if

    intcode = read_intcode(fname)
    n_codes = size(intcode)
    print "(4i5)", intcode
    print *, n_codes
    deallocate(intcode)

    contains
        function read_intcode(fname)
            integer, parameter :: fstr_len = 10000
            character(*), intent(in) :: fname
            integer, allocatable :: read_intcode(:)
            character(fstr_len) :: fstr
            integer :: fstr_true_len
            integer :: n_values = 0
            integer :: i
            open(10, file=fname)
            read(10, "(A)") fstr
            close(10)
            fstr_true_len = len_trim(fstr)
            do i=1, fstr_true_len
                if (fstr(i:i) .eq. ',') n_values = n_values + 1
            end do
            allocate(read_intcode(0:n_values))
            print *, n_values
            read(fstr, *) read_intcode
        end function read_intcode
end program day2
